# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class AbusesVideo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'float',
        'start_at': 'int',
        'end_at': 'int'
    }

    attribute_map = {
        'id': 'id',
        'start_at': 'startAt',
        'end_at': 'endAt'
    }

    def __init__(self, id=None, start_at=None, end_at=None, local_vars_configuration=None):  # noqa: E501
        """AbusesVideo - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._start_at = None
        self._end_at = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if start_at is not None:
            self.start_at = start_at
        if end_at is not None:
            self.end_at = end_at

    @property
    def id(self):
        """Gets the id of this AbusesVideo.  # noqa: E501

        Video id to report  # noqa: E501

        :return: The id of this AbusesVideo.  # noqa: E501
        :rtype: float
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AbusesVideo.

        Video id to report  # noqa: E501

        :param id: The id of this AbusesVideo.  # noqa: E501
        :type id: float
        """

        self._id = id

    @property
    def start_at(self):
        """Gets the start_at of this AbusesVideo.  # noqa: E501

        Timestamp in the video that marks the beginning of the report  # noqa: E501

        :return: The start_at of this AbusesVideo.  # noqa: E501
        :rtype: int
        """
        return self._start_at

    @start_at.setter
    def start_at(self, start_at):
        """Sets the start_at of this AbusesVideo.

        Timestamp in the video that marks the beginning of the report  # noqa: E501

        :param start_at: The start_at of this AbusesVideo.  # noqa: E501
        :type start_at: int
        """
        if (self.local_vars_configuration.client_side_validation and
                start_at is not None and start_at < 0):  # noqa: E501
            raise ValueError("Invalid value for `start_at`, must be a value greater than or equal to `0`")  # noqa: E501

        self._start_at = start_at

    @property
    def end_at(self):
        """Gets the end_at of this AbusesVideo.  # noqa: E501

        Timestamp in the video that marks the ending of the report  # noqa: E501

        :return: The end_at of this AbusesVideo.  # noqa: E501
        :rtype: int
        """
        return self._end_at

    @end_at.setter
    def end_at(self, end_at):
        """Sets the end_at of this AbusesVideo.

        Timestamp in the video that marks the ending of the report  # noqa: E501

        :param end_at: The end_at of this AbusesVideo.  # noqa: E501
        :type end_at: int
        """
        if (self.local_vars_configuration.client_side_validation and
                end_at is not None and end_at < 0):  # noqa: E501
            raise ValueError("Invalid value for `end_at`, must be a value greater than or equal to `0`")  # noqa: E501

        self._end_at = end_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AbusesVideo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AbusesVideo):
            return True

        return self.to_dict() != other.to_dict()
